{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}


unit umain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ExtCtrls, DBCtrls, Grids, DBGrids, DBClient, StdCtrls,
  System.ComponentModel;

type
  TForm1 = class(TForm)
    cds1: TClientDataSet;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    cds1PartNo: TFloatField;
    cds1VendorNo: TFloatField;
    cds1Description: TStringField;
    cds1OnHand: TFloatField;
    cds1OnOrder: TFloatField;
    cds1Cost: TCurrencyField;
    cds1ListPrice: TCurrencyField;
    cds1TotalLigneCommande: TCurrencyField;
    DBText1: TDBText;
    DBText2: TDBText;
    cds1SumOnOrder: TAggregateField;
    cds1SumCommandes: TAggregateField;
    Label1: TLabel;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cds1CalcFields(DataSet: TDataSet);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 cds1.Open;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 cds1.Close;
end;

procedure TForm1.cds1CalcFields(DataSet: TDataSet);
begin
 cds1TotalLigneCommande.AsFloat := cds1OnOrder.AsFloat * cds1ListPrice.AsFloat;
end;

end.
