{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}
unit Umain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.ComCtrls, System.ComponentModel, Borland.Vcl.Db,
  Borland.Vcl.DBClient, Borland.Vcl.Menus, Borland.Vcl.DBActns,
  Borland.Vcl.StdActns, Borland.Vcl.ActnList, Borland.Vcl.Tabs,
  Borland.Vcl.ExtCtrls, Borland.Vcl.DBCtrls, Borland.Vcl.Grids,
  Borland.Vcl.DBGrids, Borland.Vcl.StrUtils, Borland.Vcl.StdCtrls,
  Borland.Vcl.Mask,
  System.Reflection,
  System.Diagnostics,
  Borland.Vcl.ShellAPI, Nevrona.Rave.RpRender, Nevrona.Rave.RpRenderPDF,
  Nevrona.Rave.RpCon, Nevrona.Rave.RpConDS, Nevrona.Rave.RpDefine,
  Nevrona.Rave.RpRave, Nevrona.Rave.RpBase, Nevrona.Rave.RpSystem;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    pcMain: TPageControl;
    TabSheet1: TTabSheet;
    tsDetail: TTabSheet;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditDelete1: TEditDelete;
    DataSetFirst1: TDataSetFirst;
    DataSetPrior1: TDataSetPrior;
    DataSetNext1: TDataSetNext;
    DataSetLast1: TDataSetLast;
    DataSetInsert1: TDataSetInsert;
    DataSetDelete1: TDataSetDelete;
    DataSetEdit1: TDataSetEdit;
    DataSetPost1: TDataSetPost;
    DataSetCancel1: TDataSetCancel;
    FichierSauver: TAction;
    FichierQuitter: TAction;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Sauvegarderlefichier1: TMenuItem;
    N4: TMenuItem;
    Quitter1: TMenuItem;
    Edition1: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    Couper1: TMenuItem;
    N3: TMenuItem;
    Supprimer2: TMenuItem;
    outslectionner1: TMenuItem;
    Donnes1: TMenuItem;
    Premier1: TMenuItem;
    Suivante1: TMenuItem;
    Suivante2: TMenuItem;
    Dernier1: TMenuItem;
    N1: TMenuItem;
    Insertion1: TMenuItem;
    Supprimer1: TMenuItem;
    Modifier1: TMenuItem;
    N2: TMenuItem;
    Annuler1: TMenuItem;
    Valider1: TMenuItem;
    cds1: TClientDataSet;
    cds1Code: TAutoIncField;
    cds1Prnom: TStringField;
    cds1Nom: TStringField;
    cds1Surnom: TStringField;
    cds1TlphoneMaison: TStringField;
    cds1TlphonePortable: TStringField;
    cds1TlphoneTravail: TStringField;
    cds1email: TStringField;
    cds1Siteperso: TStringField;
    cds1Adresse: TMemoField;
    cds1Notes: TMemoField;
    DataSource1: TDataSource;
    od1: TOpenDialog;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    tcIndex: TTabSet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBMemo1: TDBMemo;
    DBMemo2: TDBMemo;
    DBEdit1: TDBEdit;
    DBNavigator2: TDBNavigator;
    ActAbout: TAction;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    ActPreview: TAction;
    ActPDF: TAction;
    Impression1: TMenuItem;
    Prvisualiser1: TMenuItem;
    ExportPDF1: TMenuItem;
    RvProject1: TRvProject;
    RvDataSetConnection1: TRvDataSetConnection;
    RvRenderPDF1: TRvRenderPDF;
    RvSystem1: TRvSystem;
    procedure ExportPDF1Click(Sender: TObject);
    procedure Prvisualiser1Click(Sender: TObject);
    procedure FichierSauverExecute(Sender: TObject);
    procedure FichierQuitterExecute(Sender: TObject);
    procedure cds1AfterDelete(DataSet: TDataSet);
    procedure cds1AfterPost(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tcIndexChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure ActAboutExecute(Sender: TObject);
    procedure ActPreviewExecute(Sender: TObject);
    procedure ActPDFExecute(Sender: TObject);
  private
    { Dclarations prives }
    fPath : string;
    fFilterField : string;
    fNomCalepin : string;
    procedure SaveCalepin;
    procedure CheckValidIndex;
    procedure CreateFilter; overload;
    procedure CreateFilter(Index:integer); overload;
    procedure OpenCalepin;
    procedure AppHint(sender:tobject);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

Const
      kNomParam   = 'CALEPIN.PAR';
      KNomCalepin = 'CALEPIN.XML';

implementation
uses AboutDlg;

{$R *.nfm}

procedure TForm1.FichierSauverExecute(Sender: TObject);
begin
  SaveCalepin;
end;

procedure TForm1.FichierQuitterExecute(Sender: TObject);
begin
 Close;
end;

procedure TForm1.cds1AfterDelete(DataSet: TDataSet);
begin
 CheckValidIndex;
end;

procedure TForm1.cds1AfterPost(DataSet: TDataSet);
var s:string;
begin
 cds1.DisableControls;
 try
  s:=cds1.fieldbyname('CODE').AsString;
  cds1.IndexName:='';
  cds1.IndexName:='idxPrenom';
  if trim(s)<>'' then cds1.Locate('CODE',s,[]);
 finally
  cds1.EnableControls;
 end;
 CheckValidIndex;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
fNomCalepin := KnomCalepin;
fPath := ExtractFilePath(Application.ExeName);
OpenCalepin;
if FileExists(fpath+kNomParam) then
  with tstringlist.create do
   try
     LoadFromFile(fpath+kNomParam);
     i:=StrToIntDef(Values['CURRENTFILTER'],0);
     tcIndex.TabIndex:=i;
     CreateFilter(i);
     cds1.Locate('CODE',StrToIntDef(values['CODE'],0),[]);
   finally
    free;
   end else CreateFilter;
CheckValidIndex;
Application.OnHint := AppHint;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 SaveCalepin;
 with tstringlist.Create do
  try
   Append('CODE='+cds1.fieldbyname('code').AsString);
   Append('CURRENTFILTER='+IntToStr(tcindex.TabIndex));
   savetofile(fpath+kNomParam);
  finally
   free;
  end;
end;

procedure TForm1.SaveCalepin;
begin
 if cds1.Active then
    cds1.SaveToFile(fpath+fNomCalepin,dfXML);
end;

procedure TForm1.CheckValidIndex;
var i:integer; idx:array[0..26] of integer;
    s:string; ch:char; f:boolean;
begin
 for i:=0 to 26 do idx[i]:=0;
 s:=cds1.fieldbyname('CODE').AsString;
 f:=cds1.filtered;
 cds1.DisableControls;
 try
  cds1.Filtered:=false;
  cds1.First;
  while not cds1.Eof do
   begin
    ch:=Upcase( copy(cds1.FieldByName('Prenom').AsString+' ',1,1)[1]);
    if ch in ['0'..'9'] then ch:='0';
    if ch in ['A'..'Z'] then inc(idx[ord(ch)-65]);
    if ch='0' then inc(idx[26]);
    cds1.Next;
   end;
  for i:=0 to 25 do
     tcIndex.Tabs[i] := ifthen(idx[i]>0,Char(65+i),'-');
  tcIndex.Tabs[26] := ifthen(idx[26]>0,'9','-');
  cds1.Filtered:=f;
  if trim(s)<>'' then cds1.Locate('CODE',s,[]);
 finally
  cds1.EnableControls;
 end;
end;

procedure TForm1.tcIndexChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
 CreateFilter(NewTab);
end;

procedure TForm1.CreateFilter;
begin
 CreateFilter(tcindex.TabIndex);
end;

procedure TForm1.CreateFilter(Index: integer);
begin
 cds1.DisableControls;
 try
  cds1.Filtered:=false;
  if Index=27 then exit; // "tout", aucun filtrage
  cds1.Filter := fFilterField+' LIKE '+
    quotedStr(Char(Index+65)+'%');
  cds1.Filtered:=true;
 finally
  cds1.EnableControls;
 end;
end;

procedure TForm1.OpenCalepin;
begin
if not fileExists(fpath+fNomCalepin) then
                  cds1.CreateDataSet else
                  cds1.LoadFromFile(fpath+fNomCalepin);
fFilterField := 'Prenom';
cds1.AddIndex('idxPrenom','Prenom',[ixCaseInsensitive]);
cds1.IndexName:='idxPrenom';
end;

procedure TForm1.AppHint(sender: tobject);
begin
 StatusBar1.SimpleText := Application.Hint;
end;


procedure TForm1.DBGrid1DblClick(Sender: TObject);
begin
 pcMain.TabIndex:=1;
end;

procedure TForm1.ActAboutExecute(Sender: TObject);
begin
 ShowAbout;
end;

procedure TForm1.ActPreviewExecute(Sender: TObject);
begin
// VCLReport1.Execute;
end;

procedure TForm1.ActPDFExecute(Sender: TObject);
begin
// PDFReport1.Execute;
// Screen.Cursor := crHourglass;
// ActionList1.State := asSuspended;
// try
// Shellexecute(Self.Handle,'open',PDFReport1.PDFFilename,'','',SW_SHOWNORMAL);
// finally
// ActionList1.State := asNormal;
// Screen.Cursor := crDefault;
// end;
end;

procedure TForm1.Prvisualiser1Click(Sender: TObject);
begin
 RvProject1.Open;
 RvSystem1.DefaultDest := rdPreview; //  rdfile
 RvSystem1.DoNativeOutput := true; // false;
 RvSystem1.RenderObject := nil; // RvRenderPDF1;
 RvSystem1.OutputFileName := ''; // 'calepin.pdf';
 RvSystem1.SystemSetups := RvSystem1.SystemSetups + [ssAllowSetup]; // - [ssAllowSetup];
 RvProject1.Execute;
 RvProject1.Close;
end;

procedure TForm1.ExportPDF1Click(Sender: TObject);
var p:System.Diagnostics.Process;
begin
 RvProject1.Open;
 RvSystem1.DefaultDest := rdfile;
 RvSystem1.DoNativeOutput := false;
 RvSystem1.RenderObject := RvRenderPDF1;
 RvSystem1.OutputFileName := 'calepin.pdf';
 RvSystem1.SystemSetups := RvSystem1.SystemSetups - [ssAllowSetup];
 RvProject1.Execute;
 RvProject1.Close;
 p := Process.Create;
 p.StartInfo.RedirectStandardOutput:=false;
 p.StartInfo.FileName:='calepin.pdf';
 p.StartInfo.UseShellExecute:=true;
 p.Start();
 p.WaitForExit();
 p.Dispose();
end;

end.


